package ipsk.db.speech;

import ipsk.beans.PreferredDisplayOrder;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.Transient;

@Entity
@PreferredDisplayOrder("id,propertyClassId,propertyName,required,show,*")
public class PropertyConfiguration implements ipsk.beans.form.PropertyConfiguration{
	private int id;
	private Set<FormConfiguration> formConfigurations;
	
	@ManyToMany(mappedBy="inputPropertyConfigurations")
	public Set<FormConfiguration> getFormConfigurations() {
		return formConfigurations;
	}
	public void setFormConfigurations(Set<FormConfiguration> formConfigurations) {
		this.formConfigurations = formConfigurations;
	}
	@Id
	@Column(name = "id", unique = true, nullable = false)
    @GeneratedValue(generator="id_gen")
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	private String propertyClassId;
	
	@Column
	public String getPropertyClassId() {
		return propertyClassId;
	}
	public void setPropertyClassId(String propertyClassId) {
		this.propertyClassId = propertyClassId;
	}
	@Column
	public String getPropertyName() {
		return propertyName;
	}
	public void setPropertyName(String propertyName) {
		this.propertyName = propertyName;
	}
	@Column
	public TypedPropertyDescriptor getTypedPropertyDescriptor() {
		return typedPropertyDescriptor;
	}
	public void setTypedPropertyDescriptor(
			TypedPropertyDescriptor typedPropertyDescriptor) {
		this.typedPropertyDescriptor = typedPropertyDescriptor;
	}
	@Column
	public boolean isRequired() {
		return required;
	}
	public void setRequired(boolean required) {
		this.required = required;
	}
	@Column
	public boolean isShow() {
		return show;
	}
	public void setShow(boolean show) {
		this.show = show;
	}
	private String propertyName;
	private TypedPropertyDescriptor typedPropertyDescriptor;
	private boolean required=true;
	private boolean show=true;

//	@Override
	@Transient
	public Class<?> getBeanClass() {
		
		String pcid=getPropertyClassId();
		String pcClassName=pcid.replaceFirst("java:","");
		try {
			return Class.forName(pcClassName);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// TODO see Speechrecorder XML class name coding
		return null;
	}
//	@Override
	@Transient
	public PropertyDescriptor getPropertyDescriptor() {
		Class<?> c=getBeanClass();
		BeanInfo bi;
		try {
			bi = Introspector.getBeanInfo(c);
			PropertyDescriptor[] pds=bi.getPropertyDescriptors();
			String pName=getPropertyName();
			for(PropertyDescriptor pd:pds){
				if(pd.getName().equals(pName)){
					return pd;
				}
			}
		} catch (IntrospectionException e) {
			return null;
		}
		
		return null;
	}
}
